Subject: Re: RFC 2460 issue

From: Suresh Krishnan <[email-masked]>
Date: Wed, 29 Oct 2003 09:05:06 -0500 (EST)

Hi Fred,
  I agree that an ICMPv6 message should be sent by the router but I 
think it should be the Time Exceeded message (RFC 2463, section 3.3) 
rather than a parameter problem (section 3.4) message. 

Regards
Suresh

On Tue, 28 Oct 2003, Fred Templin wrote:

>Don't know about the sending host, but perhaps the next forwarding
>hop should send an ICMPv6 parameter problem message (RFC 2463,
>section 3.4) if it gets a packet with Hop Count = 0?
>
>Trouble is, the original source of the IPv6 packet might be different
>than the previous hop which made the mistake forwarding the packet
>with Hop Count = 0. So, the ICMPv6 parameter problem message
>might  be of little value to the original source.
>
>Fred
>[email-masked]
> 
>
>Alain Durand wrote:
>
>> I had this question yesterday and I couldn't find an answer in RFC2460:
>>
>> Is it valid for a host to send a packet with Hop Count set to zero?
>>
>>     - Alain.
>>
>>
>>
>> --------------------------------------------------------------------
>> IETF IPv6 working group mailing list
>> [email-masked]
>> Administrative Requests: https://www1.ietf.org/mailman/listinfo/ipv6
>> --------------------------------------------------------------------
>
>
>
>
>--------------------------------------------------------------------
>IETF IPv6 working group mailing list
>[email-masked]
>Administrative Requests: https://www1.ietf.org/mailman/listinfo/ipv6
>--------------------------------------------------------------------
>

--------------------------------------------------------------------
IETF IPv6 working group mailing list
[email-masked]
Administrative Requests: https://www1.ietf.org/mailman/listinfo/ipv6
--------------------------------------------------------------------

---

From: "KASSI-LAHLOU Mohammed FTRD/DMI/CAE" <[email-masked]>
Date: Wed, 29 Oct 2003 15:58:24 +0100

Hi,

The RFC 2460 says:

"Hop Limit            8-bit unsigned integer.  Decremented by 1 by
                      each node that forwards the packet. The packet
                      is discarded if Hop Limit is decremented to
                      zero."

IMHO, this means: when the Hop Limit=0 the packet is discarded.
Now, if the packet is sent with Hop Limit=0, the forwarding (in the next hop) decrements the Hop Limit and the result of 0-1 is 255 thus the packet is not dropped but forwarded.

Kassi

-----Message d'origine-----
De : Markku Savela [mailto:[email-masked]] 
Envoyé : mardi 28 octobre 2003 21:21
À : [email-masked]
Cc : [email-masked]; [email-masked]; [email-masked]; [email-masked]
Objet : Re: RFC 2460 issue

> Off the top of my head I know that RFC3493 needs to be updated since 
> the IPV6_UNICAST_HOPS socket option now accepts 0 as a valid hop 
> count. I really do not understand what a hop count of 0 implies and 
> why we should bother updating the RFCs.

Heh, yes. I too wondered about what I should do if application sets TTL = 0. There are two choices

 a) Packets go to /dev/null (perhaps some obscure testing feature?)

 b) Just let packets with TTL=0 go out.

I chose (b), because

 - TTL is naturally checked only on fowarding, not when sending
   own packets out. Thus, any TTL just gets accepted and sent.

If packet with TTL=0 is for this node, it is accepted (again, because TTL test is only for forwarding).

Forwarding decrements TTL and if result is 0 or < 0, packet dropped (with appropriate ICMP if needed).

I'm happy with above semantics. I don't see any need to worry about it too much.